/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 * Copyright (C) 2010 OBJECT FANATICS Co.,Ltd. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.constraints;

import static java.lang.annotation.ElementType.ANNOTATION_TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * TODO: このパッケージのアノテーションを直接利用しない実行環境では、実行時にこのパッケージのアノテーションに依存する必要はない。
 * 　　　　しかし、リフレクション経由で参照されてしまうような場合があり、その場合には ClassNotFoundException が発生してしまう。
 * 　　　　そのため、このパッケージのmaven用モジュールのスコープは compile にしておく。あえてこの依存関係を runtime で除外したい場合も
 * 　　　　ありうるので、その場合の方法の説明を各種ドキュメント(ant の task用ドキュメントとか)に載せておきましょう。
 */
//DOUBLE_CHECKED 04.04.2010
/**
 * Marker annotation for constraint annotation.
 * 
 * @author Makoto Sato
 * @author Hirokatsu Endo
 */
@Documented
@Retention(RUNTIME)
@Target( { ANNOTATION_TYPE })
public @interface ConstraintAnnotation {
}
