/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 * Copyright (C) 2010 OBJECT FANATICS Co.,Ltd. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.constraints;

import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.ElementType.PARAMETER;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

//DOUBLE_CHECKED 04.04.2010
/**
 * The annotated element must not be <code>null</code>.
 * <p/>
 * Supported types are:
 * <ul>
 *   <li><code>Object</code></li>
 * </ul>
 * <p/>
 * Primitive types and void are not supported.
 * 
 * @author Makoto Sato
 * @author Hirokatsu Endo
 */
@Documented
@Retention(RUNTIME)
@Target( { METHOD, PARAMETER })
@ConstraintAnnotation
public @interface NotNull {
}
